#include "header\GBA.h"
#include "header\BG.h"
#include "header\Timer.h"
#include "header\DMA.h"
#include "header\IRQ.h"
#include "header\sound.h"
#include "header\sprite.h"
#include "header\Blend.h"

#include "lib.h"
#include "iwram.h"
#include "irq.h"
#include "syscall.h"

#include <string.h>
#include <stdlib.h>

#include "resource.h"
#include "resource\BitMapFont.h"
//#include "resource\BGFont.h"

//---------------------------------------------------------------------------
#define TRUE  (1)
#define FALSE (0)

#define WALL_BLANK_LENGTH  64
#define SCREEN_MIN_X       0
#define SCREEN_MIN_Y       0
#define SCREEN_MAX_X       239
#define SCREEN_MAX_Y       159
#define COLOR_RED          RGB(31, 0, 0)
#define COLOR_BLACK        RGB( 0, 0, 0)
#define COLOR_WHITE        RGB(31,31,31)

//---------------------------------------------------------------------------
typedef struct {
	s16  x;
	s16  y;
	s16  dx;		//ړω
	s16  dy;
}ST_PLAYER;

ST_PLAYER   PLAYER;

u8 GameClearFlag;
//---------------------------------------------------------------------------
void Init();
void Input();

void ChkClear();
void ChkPlayer();

void DrawPlayer();
void DrawWall();
//---------------------------------------------------------------------------
int main(void)
{
	Mode3SetBitMapFont((u8*)BitMapFont, 8,8,0);
	Mode3DrawBitMapStr(1,18, "Push A Button");

	SetMode(MODE_3 | BG2_ENABLE);
	WaitKey(KEY_A);		//srand

GameStart:

	Init();
	DrawWall();

	for(;;)
	{
		WaitForVsync();

		DrawPlayer();
		Input();

		ChkClear();
		ChkPlayer();

		if(GameClearFlag == TRUE)
		{
			break;
		}
	}

	Mode3DrawBitMapStr(1,18, "Game Over!");
	WaitKey(KEY_A);

	goto GameStart;
	
	for(;;){}
	return 0;
}
//---------------------------------------------------------------------------
void Init()
{
	PLAYER.x  = 0;
	PLAYER.y  = 0;
	PLAYER.dx = 1;
	PLAYER.dy = 0;

	GameClearFlag = FALSE;

	Mode3DrawCls(0x0000);
}
//---------------------------------------------------------------------------
void DrawWall()
{
	s16 y1 = 0;
	s16 y2 = WALL_BLANK_LENGTH;

	Mode3DrawBox(32,0,SCREEN_CX,SCREEN_CY,COLOR_RED);

	u8 x;
	for(x=32; x<SCREEN_CX; x++)
	{
		if(y1 < SCREEN_MIN_Y)
		{
			y1 = SCREEN_MIN_Y;
		}
		if(y1 > SCREEN_MAX_Y - WALL_BLANK_LENGTH)
		{
			y1 = SCREEN_MAX_Y - WALL_BLANK_LENGTH;
		}

		Mode3DrawLine(x,y1,x,y2,COLOR_BLACK); //

		//ǂ̕ωʁi-7`+7j
		y1 = y1 + rand()%15 - 7;
		y2 = y1 + WALL_BLANK_LENGTH;
	}
}
//---------------------------------------------------------------------------
void DrawPlayer()
{
	Mode3DrawDot(PLAYER.x, PLAYER.y, COLOR_WHITE);
}
//---------------------------------------------------------------------------
void Input()
{
	KeyInitialize();
	u8 Key = KeyInput();

	if(Key & KEY_A) PLAYER.dy--;
	else            PLAYER.dy++;

	//ωʂ̌vZ
	if(PLAYER.dy > 12) PLAYER.dy =  12;
	if(PLAYER.dy <-12) PLAYER.dy = -12;

	PLAYER.x += PLAYER.dx;
	PLAYER.y += PLAYER.dy / 4;

	if(PLAYER.y < SCREEN_MIN_Y) PLAYER.y = SCREEN_MIN_Y;
	if(PLAYER.y > SCREEN_MAX_Y) PLAYER.y = SCREEN_MAX_Y;
}
//---------------------------------------------------------------------------
void ChkClear()
{
	if(PLAYER.x < SCREEN_MAX_X)
	{
		return;
	}
	GameClearFlag = TRUE;
}
//---------------------------------------------------------------------------
void ChkPlayer()
{
	if( Mode3GetDotRGB(PLAYER.x, PLAYER.y) == COLOR_BLACK )
	{
		return;
	}
	GameClearFlag = TRUE;
}
